//BIOMES

const biomes = [1, 4, 5, 27, 155, 19];

var Autumn = new CustomBiome("autumn")
.setGrassColor(0xFF8C00)
.setFoliageColor(0xFF8C00)
//may be 0xFF4500
.setCoverBlock(2, 0)
.setSurfaceBlock(3, 0)
.setFillingBlock(1, 0);

Callback.addCallback("GenerateBiomeMap", function (chunkX, chunkZ, random, dimensionId, chunkSeed, worldSeed, dimensionSeed) {
if (dimensionId != 0) return;
 var X = Math.floor(chunkX) * 16;
  var Z = Math.floor(chunkZ) * 16;
   var biome = World.getBiomeMap(X + 4, Z + 4);
   for(var j in biomes){
    if (biome != biomes[j]) return;
     if (GenerationUtils.getPerlinNoise(X + 4, 0, Z + 4, dimensionSeed, 1 / 256, 2) < .56 - 4 / Math.pow(256, 2))
      return;
     for (var x = 0; x < 16; x++) {
      for (var z = 0; z < 16; z++) {
          var noiseValue = GenerationUtils.getPerlinNoise(X + 4, 0, Z + 4, dimensionSeed, 1 / 256, 2);
           if (noiseValue > .56)
             World.setBiomeMap(x, z, Autumn.id);
            }
        }
    }
});

var MapleWoods = new CustomBiome("maple_woods")
.setCoverBlock(2, 0)
.setSurfaceBlock(1, 0)
.setFillingBlock(3, 0);

Callback.addCallback("GenerateBiomeMap", function (chunkX, chunkZ, random, dimensionId, chunkSeed, worldSeed, dimensionSeed) {
if (dimensionId != 0) return;
 var X = Math.floor(chunkX) * 16;
  var Z = Math.floor(chunkZ) * 16;
   var biome = World.getBiomeMap(X + 8, Z + 8);
   for(var j in biomes){
    if (biome != biomes[j]) return;
     if (GenerationUtils.getPerlinNoise(X + 8, 0, Z + 8, dimensionSeed, 1 / 256, 2) < .6 - 4 / Math.pow(256, 2))
      return;
     for (var x = 0; x < 16; x++) {
      for (var z = 0; z < 16; z++) {
          var noiseValue = GenerationUtils.getPerlinNoise(X + 8, 0, Z + 8, dimensionSeed, 1 / 256, 2);
           if (noiseValue > .6)
             World.setBiomeMap(x, z, MapleWoods.id);
            }
        }
    }
});

//MAIN

Callback.addCallback("GenerateChunk", function(chunkX, chunkZ, random) {
var coords = GenerationUtils.randomCoords(chunkX, chunkZ);
 coords = GenerationUtils.findSurface(coords.x, 95, coords.z);
 var Biome = World.getBiome(coords.x, coords.z);
  var regi = BlockSource.getCurrentWorldGenRegion();
if(coords.y < 56) return;
for (var x = 0; x < randomInt(3, 5); x++) {
 for (var z = 0; z < randomInt(3, 5); z++) {
     
  if (Biome == MapleWoods.id || Biome == 4  && random.nextFloat() < .4) {
    if(World.getBlockID(coords.x, coords.y, coords.z) == 2 && World.getBlockID(coords.x, coords.y + 1, coords.z) == 0) 
      World.setBlock(coords.x + x, coords.y + 1, coords.z + z, BlockID.mapleLeavesC, 0); 
        }

  if (Biome == Autumn.id && random.nextFloat() < .42) {
    if(World.getBlockID(coords.x, coords.y, coords.z) == 2 && World.getBlockID(coords.x, coords.y + 1, coords.z) == 0)   
      World.setBlock(coords.x + x, coords.y + 1, coords.z + z, BlockID.mapleLeavesAuC, 0); 
        }

  if (Biome == Autumn.id && random.nextFloat() < .32) {
    if(World.getBlockID(coords.x, coords.y, coords.z) == 2 && World.getBlockID(coords.x, coords.y + 1, coords.z) == 0)   
      World.setBlock(coords.x + x, coords.y + 1, coords.z + z, BlockID.mapleLeavesAuRedC, 0); 
        }

  if (Biome == 30 || Biome == 31 || Biome == 34 && random.nextFloat() < .3) {
    if(World.getBlockID(coords.x, coords.y, coords.z) == 2 && World.getBlockID(coords.x, coords.y + 1, coords.z) == 0)   
      World.setBlock(coords.x + x, coords.y + 1, coords.z + z, BlockID.mapleLeavesWhinterC, 0); 
        }
    } 
}

for (var x = 0; x < randomInt(1, 3); x++) {
 for (var Z = 0; z < randomInt(2, 3); z++) {
  if (Biome == Autumn.id || Biome == MapleWoods.id && random.nextFloat() < .4) {
    if(World.getBlockID(coords.x, coords.y, coords.z) == 2) {
      World.setBlock(coords.x + x, coords.y + 1, coords.z + z, BlockID.foulBerriedBush, 0); 
      World.setBlock(coords.x + x, coords.y + 2, coords.z + z, BlockID.foulBerriedBushTop, 0); 
             }
        }

  if (Biome == Autumn.id && random.nextFloat() < .45) {
    if(World.getBlockID(coords.x, coords.y, coords.z) == 2) 
      World.setBlock(coords.x + x, coords.y + 1, coords.z + z, BlockID.autumnCrocus, 0); 
        }
    }
}

//NORMAL_TREES
generateStructureInBiomes([Autumn.id], {str: mapleA, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .52, biomed: .52}}, random);
generateStructureInBiomes([Autumn.id, MapleWoods.id], {str: mapleR, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .4, biomed: .24}}, random);
generateStructureInBiomes([MapleWoods.id, Autumn.id], {str: mapleG, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .48, biomed: .24}}, random);
generateStructureInBiomes([30, 31, 34], {str: mapleW, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .48, biomed: .2}}, random);

//BIG_TREES
generateStructureInBiomes([Autumn.id], {str: mapleBA, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .26, biomed: .26}}, random);
generateStructureInBiomes([Autumn.id, MapleWoods.id], {str: mapleBR, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .3, biomed: .16}}, random);
generateStructureInBiomes([MapleWoods.id, Autumn.id], {str: mapleBG, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .32, biomed: .16}}, random);
generateStructureInBiomes([30, 31, 34], {str: mapleBW, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .3, biomed: .2}}, random);

//BUSHES
generateStructureInBiomes([Autumn.id], {str: bushA, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal:.16, biomed: .16}}, random);
generateStructureInBiomes([Autumn.id, MapleWoods.id], {str: bushR, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .2, biomed: .1}}, random);
generateStructureInBiomes([MapleWoods.id, Autumn.id], {str: bushG, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .18, biomed: .1}}, random);
generateStructureInBiomes([30, 31, 34], {str: bushW, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal:.14, biomed: .1}}, random);
generateStructureInBiomes([4, 1, 29, 6], {str: bushVO, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .12, biomed: .12}}, random);
generateStructureInBiomes([5, 160, 32], {str: bushVS, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .12, biomed: .12}}, random);

//CAMP
generateStructureInBiomes([5, 160, 32, 30], {str: fireN, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .12, biomed: .12}}, random);
generateStructureInBiomes([5, 160, 32, 30], {str: fireL, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .12, biomed: .12}}, random);
generateStructureInBiomes([30, 31, 34], {str: thriveN, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .05, biomed: .05}}, random);
generateStructureInBiomes([30, 31, 34], {str: thriveL, x: coords.x, y: coords.y, z: coords.z, region: regi, check: 2, chance: {normal: .03, biomed: .03}}, random);
});